/* h.dboxDX */

#include "menu.h"
#include "event.h"

typedef void *dbox;

typedef BOOL (*dbox_raw_handler_proc)(dbox, wimp_eventstr *event, void *handle);
typedef void (*dbox_handler_proc)(dbox, void *handle);
typedef void (*dbox_update_proc)(dbox,wimp_redrawstr*, void *handle);

void JWin_redraw_win(wimp_w w,int nicons);

void dbox_init(char);
dbox dbox_new(char *);
void dbox_attach_update(dbox,dbox_update_proc,void *);
dbox dbox_lastdbox(void);
void dbox_registerhelp(dbox,char *);
void dbox_dispose(dbox *);
void dbox_show(dbox);
void dbox_show_default(dbox);
void dbox_showstatic(dbox);
void dbox_hide(dbox);
void dbox_setfield(dbox,int,char *);
void dbox_getfield(dbox,int,char *,int);
void dbox_setnumeric(dbox,int,int);
int dbox_getnumeric(dbox,int);
void dbox_fadefield(dbox,int);
void dbox_unfadefield(dbox,int);
int dbox_get(dbox);
int dbox_read(dbox);
void dbox_eventhandler(dbox,dbox_handler_proc,void *);
void dbox_raw_eventhandler(dbox,dbox_raw_handler_proc,void *);
int dbox_fillin(dbox);
int dbox_fillin_fixed_caret(dbox);
int dbox_popup(char *, char *);
BOOL dbox_persist(void);
int dbox_syshandle(dbox);
BOOL dbox_attach_menu_to_icon(dbox,int,event_menu_maker,event_menu_proc,void *);
BOOL dbox_attach_menu(dbox,event_menu_maker,event_menu_proc,void *);
void dbox_setbackcolour(dbox,int,int);
void dbox_setforecolour(dbox,int,int);
void JWin_mh(wimp_eventstr *e,void *handle);
int dbox_warn(char *name,int);
void dbox_allow_null(dbox,int);
void dbox_adjust_close(dbox);
void dbox_nextsave_fade(int);
BOOL dbox_adjust_closed(dbox);
